Subject: [netmod] Ambiguity on list entry deletion using edit-config

From: Qin Wu <[email-masked]>
Date: Sat, 10 Nov 2018 16:18:14 +0000

Hi,
I have confusion on list entry deletion operation defined in RFC7950.
RFC7950 said:
"
List entries can be deleted through <edit-config> by using the "operation" attribute in the list's XML
element. When a NETCONF server processes an <edit-config> request, if the operation is "delete", the entry
is deleted from the list if it exists.  If the list entry does not exist, a "data-missing"
error is returned.
"
I am wondering how do we define the list entry exist in the above Quoted text?
A list entry may include one or multiple key leafs and/or one of multiple non-key leafs.
Do we just check if requested list entry with specified key leafs exist in the list of target datastore
or do we need to check if the requested list entry with all specified leafs including key leafs and non-key leafs
exist in the list of target datastore?

In other words, do we need to validate non-key leafs within the list? What about requested list entry with specified
key leaf matching corresponding key leaf in the list of target datastore while specified non-key leaf not matching?

Do we judge this as the list entry not exist and report "data-missing" error?
or we should report new error "non-key-data-mismatching"?

If we follows RFC7950 rule and judge this case as the list entry doesn't exist, I feel this rule is too strict and RFC7950
doesn't clarify whether validation on leaf of list is required.

If my understanding is correct, if the key leaf matches, the corresponding leaf list will be delete even though
non-key leafs mismatches? But this seems not complaint with RFC7950?

Comments or clarification?

-Qin